//
//  ProductListPagePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxCocoa
import RxSwift
import Action


protocol ProductListPageWireframeInterface: WireframeInterface {
}

protocol ProductListPageViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[ProductItemViewModel]> { get }
}

final class ProductListPagePresenter: ProductListPagePresenterInterface {

    // MARK: - Private properties -
    private lazy var getProductsAction = makeGetProductsListAction()
    private let disposeBag = DisposeBag()

    private unowned let view: ProductListPageViewInterface
    private let interactor: ProductListPageInteractorInterface
    private let wireframe: ProductListPageWireframeInterface

    // MARK: - Lifecycle -

    init(view: ProductListPageViewInterface, interactor: ProductListPageInteractorInterface, wireframe: ProductListPageWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configurePresenter()
    }
}

// MARK: - Extensions -

extension ProductListPagePresenter {
    func configurePresenter() {
        getProductsAction
            .elements
            .map { $0.map { ProductItemViewModel(model: $0) } }
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
        
        getProductsAction.execute()
    }
    
    func configureViewActions() {
    }
}

extension ProductListPagePresenter
{
    func makeGetProductsListAction() -> Action<Void, [Product]> {
        return Action<Void, [Product]> { [unowned self] in
            return self.interactor.getProducts()
        }
    }
}

